package hhc_ast

import "git.swzry.com/zry/go-hhc-cli/hhc_common"

type SDTNode_End struct {
	Parent SyntaxDefTreeNode
	Exec   ExecuteFunc
}

func (n *SDTNode_End) IsEnd() bool {
	return true
}

func (n *SDTNode_End) WalkNext(ctx *SDTWalkContext, token string) (SyntaxDefTreeNode, hhc_common.SDTWalkError) {
	return nil, hhc_common.SDTWalkError_TooManyParameters{}
}

func (n *SDTNode_End) GetHelps(prefix string) []hhc_common.SDTHelpInfo {
	return []hhc_common.SDTHelpInfo{}
}

func (n *SDTNode_End) Fallback(ctx *SDTWalkContext) (SyntaxDefTreeNode, hhc_common.SDTWalkError) {
	if n.Parent != nil {
		if len(ctx.ASTNodes) > 0 {
			ctx.ASTNodes = ctx.ASTNodes[:len(ctx.ASTNodes)-1]
		}
		return n.Parent, nil
	} else {
		return nil, hhc_common.SDTWalkError_LossingParent{RelyName: "#End"}
	}
}

func (n *SDTNode_End) GetExecuteFunc() ExecuteFunc {
	return n.Exec
}
